/*
 *  ========================================================================
 *  DIScrete event baSed Energy Consumption simulaTor 
 *    					             for Clouds and Federations (DISSECT-CF)
 *  ========================================================================
 *  
 *  This file is part of DISSECT-CF.
 *  
 *  DISSECT-CF is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or (at
 *  your option) any later version.
 *  
 *  DISSECT-CF is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
 *  General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with DISSECT-CF.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  (C) Copyright 2013, Gabor Kecskemeti (gkecskem@dps.uibk.ac.at,
 *   									  kecskemeti.gabor@sztaki.mta.hu)
 */

package hu.mta.sztaki.lpds.cloud.simulator.iaas;

import java.util.List;

import hu.mta.sztaki.lpds.cloud.simulator.storage.NetworkNode;
import hu.mta.sztaki.lpds.cloud.simulator.storage.Repository;
import hu.mta.sztaki.lpds.cloud.simulator.storage.VirtualAppliance;

public interface VMManager<E> {

	public static class VMManagementException extends Exception {

		private static final long serialVersionUID = 4420666848803005233L;

		public VMManagementException(final String message) {
			super(message);
		}
	}

	public static class NoSuchVMException extends VMManagementException {
		private static final long serialVersionUID = 777996106319988828L;

		public NoSuchVMException(final String message) {
			super(message);
		}
	}

	public VirtualMachine requestVM(VirtualAppliance va, Repository vaSource)
			throws VMManagementException, NetworkNode.NetworkException;

	public void terminateVM(VirtualMachine vm) throws NoSuchVMException,
			VMManagementException;

	public void migrateVM(VirtualMachine vm, E target)
			throws NoSuchVMException, VMManagementException, NetworkNode.NetworkException;

	public void reallocateResources(VirtualMachine vm,
			VirtualAppliance newresources) throws NoSuchVMException,
			VMManagementException;

	public List<VirtualMachine> listVMs();
}
